#import "C:\Program Files\Common Files\System\ADO\msado15.dll" \
    no_namespace rename("EOF", "EndOfFile")

#include "ADO_DataBase.h"
#include "stdio.h"
#include "stdlib.h"
#include "stdarg.h"

LogFile ADO_DataBase::m_LogFile = LogFile();

ADO_DataBase::~ADO_DataBase()
{
	CoUninitialize();
	//m_pConn->Close();
}


HRESULT ADO_DataBase::Init()
{
	if FAILED(CoInitialize(NULL))
	{
		CoUninitialize();
		return E_UNEXPECTED;
	}

	m_pRS = NULL;
	m_pConn = NULL;
	//m_pComm = NULL;
	memset(m_pConnString,0,512);
	memset(m_pUserId,0,256);
	memset(m_pUserPassword,0,256);
	memset(m_pQueryString,0,1024);
	memset(m_pProvider,0,256);
	memset(m_pDataSource,0,MAX_PATH);
	memset(m_pInitialCatalog,0,256);
	memset(m_pExtendedProperties,0,256);
	m_ConnectOption = adConnectUnspecified;
	m_CursorType = adOpenForwardOnly;
	m_LockType = adLockUnspecified;
	m_lOptions = adCmdText;
	
	return S_OK;
}

void ADO_DataBase::SetUserId(const char* a_pUserId)
{
	try
	{
		strcpy(m_pUserId,a_pUserId);
	}catch(...)
	{
		printf("Fatal Error!!\nUser Id cannot be set!!");
		//exit(0);
	}
}

void ADO_DataBase::SetUserPassword(const char* a_pUserPassword)
{
	try
	{
		strcpy(m_pUserPassword,a_pUserPassword);
	}catch(...)
	{
		printf("Fatal Error!!\nUser Password cannot be set!!");
		//exit(0);
	}
}

void ADO_DataBase::SetQueryString(const char* a_pQueryString)
{
	try
	{
		strcpy(m_pQueryString,a_pQueryString);
	}catch(...)
	{
		printf("Fatal Error!!\nQuery String cannot be set!!");
		//exit(0);
	}
}

void ADO_DataBase::SetProvider(const char* a_pProvider)
{
	try
	{
		strcpy(m_pProvider,a_pProvider);
	}catch(...)
	{
		printf("Fatal Error!!\nProvider cannot be set!!");
		exit(0);
	}
}

void ADO_DataBase::SetDataSource(const char* a_pDataSource)
{
	try
	{
		strcpy(m_pDataSource,a_pDataSource);
	}catch(...)
	{
		printf("Fatal Error!!\nData Source cannot be set!!");
		//exit(0);
	}
}

void ADO_DataBase::SetInitialCatalog(const char* a_pInitialCatalog)
{
	try
	{
		strcpy(m_pInitialCatalog,a_pInitialCatalog);
	}catch(...)
	{
		printf("Fatal Error!!\nInitial Catalog cannot be set!!");
		//exit(0);
	}
}


void ADO_DataBase::SetExtendedProperties(const char* a_pExtendedProperties)
{
	try
	{
		strcpy(m_pExtendedProperties,a_pExtendedProperties);
	}catch(...)
	{
		printf("Fatal Error!!\nExtended Properties cannot be set!!");
		//exit(0);
	}
}

void ADO_DataBase::SetConnString(const char* a_pConnString)
{
	try
	{
		strcpy(m_pConnString,a_pConnString);
	}catch(...)
	{
		printf("Fatal Error!!\nConnection String cannot be set!!");
		exit(0);
	}
}

void ADO_DataBase::SetConnectionTimeOut(const int a_iConnTimeOut)
{
	try
	{
		m_pConn->ConnectionTimeout = a_iConnTimeOut;
	}
	catch(_com_error &a_pComError)
	{
		LogCOMExceptions(a_pComError);
		LogProviderExceptions(m_pConn);
	}
}

char* ADO_DataBase::BuildConnString()
{
	try
	{
		sprintf(m_pConnString,"Provider=%s;Data Source=%s;Initial Catalog=%s;Extended Properties=%s;User Id=%s;Password=%s;",\
			m_pProvider,m_pDataSource,m_pInitialCatalog,m_pExtendedProperties,m_pUserId,m_pUserPassword);
		return m_pConnString;
	}
	catch(...)
	{
		printf("Fatal Error!!\nConnection String cannot be built!!");
		return NULL;
		//exit(0);
	}
}

void ADO_DataBase::SetConnectOption(ConnectOptionEnum a_ConnectOption = adConnectUnspecified)
{
	m_ConnectOption = a_ConnectOption;
}

HRESULT ADO_DataBase::ConnectToDB()
{
	HRESULT hr = S_OK;
	try
	{
		hr = m_pConn.CreateInstance(__uuidof(Connection));
		hr = m_pConn->Open(m_pConnString,m_pUserId,m_pUserPassword,m_ConnectOption);
		return hr;
	}
	catch(_com_error &a_pComError)
	{
		LogCOMExceptions(a_pComError);
		LogProviderExceptions(m_pConn);
		return E_UNEXPECTED;
	}
}

void ADO_DataBase::SetCursorType(CursorTypeEnum a_CursorType)
{
	m_CursorType = a_CursorType;
}

void ADO_DataBase::SetLockType(LockTypeEnum a_LockType)
{
	m_LockType = a_LockType;
}

void ADO_DataBase::SetOpenRecordSetOptions(long a_lOptions)
{
	m_lOptions = a_lOptions;
}

_RecordsetPtr ADO_DataBase::GetRecordSet()
{
	try
	{
		m_pRS.CreateInstance(__uuidof(Recordset));
		m_pRS->Open(m_pQueryString, m_pConn.GetInterfacePtr(), m_CursorType, m_LockType, m_lOptions);
		return m_pRS;
	}
	catch(_com_error &a_pComError)
	{
		LogCOMExceptions(a_pComError);
		LogProviderExceptions(m_pConn);
		return NULL;
	}
}

void ADO_DataBase::PrintRecordSet(const long a_lNoOfRecords = 30)
{
	try
	{
		m_pRS->MoveFirst();
		_bstr_t bstrRecordsSet= m_pRS->GetString(adClipString,a_lNoOfRecords,"\t","\n","");
		printf("\nListing of all Records:\n");
		printf("%s",(LPCSTR)bstrRecordsSet);
	}
	catch(_com_error &a_pComError)
	{
		LogCOMExceptions(a_pComError);
		LogProviderExceptions(m_pConn);	
	}
}

_RecordsetPtr ADO_DataBase::ExecuteQuery()
{
	try
	{
		m_LogFile.WriteToLogFile(m_pQueryString);
		m_pRS = m_pConn->Execute(m_pQueryString,NULL,m_lOptions);
		return m_pRS;
	}
	catch(_com_error &a_pComError)
	{
		LogCOMExceptions(a_pComError);
		//LogProviderExceptions(m_pConn);
		return NULL;
	}
}

_RecordsetPtr ADO_DataBase::ExecuteQuery(char a_pQueryString[1024])
{
	try
	{
		m_LogFile.WriteToLogFile(a_pQueryString);
		m_pRS =  m_pConn->Execute(a_pQueryString,NULL,m_lOptions);
		return m_pRS;
	}
	catch(_com_error &a_pComError)
	{
		LogCOMExceptions(a_pComError);
		//LogProviderExceptions(m_pConn);
		return NULL;
	}
}

void ADO_DataBase::LogCOMExceptions(_com_error &a_pComError)
{
	try
	{
		char l_pchErrorString[512];
		sprintf(l_pchErrorString,"Error Start: ---------------------------------\
						\nCode = %08lx\nMessage = %s\nSource = %s\nDescription = %s\
						\nError End ------------------------------\n",\
			a_pComError.Error(),a_pComError.ErrorMessage(),(LPCSTR) a_pComError.Source(),\
			(LPCSTR) a_pComError.Description());
		m_LogFile.WriteToLogFile(l_pchErrorString);
	}
	catch(...)
	{
	}
}

void ADO_DataBase::LogProviderExceptions(_ConnectionPtr a_pConnPtr)
{
	try
	{
	
		// Print Provider Errors from Connection object.
		// pErr is a record object in the Connection's Error collection.
		ErrorPtr  pErr = NULL;

		if( (a_pConnPtr->Errors->Count) > 0)
		{
				long nCount = a_pConnPtr->Errors->Count;
				// Collection ranges from 0 to nCount -1.
				for(long i = 0; i < nCount; i++)
				{
						pErr = a_pConnPtr->Errors->GetItem(i);
						char l_pchErrorString[512];
						sprintf(l_pchErrorString,"Error:\n Error number: %x\t%s", pErr->Number,
								pErr->Description);
						m_LogFile.WriteToLogFile(l_pchErrorString);
					
				}
		}
	}
	catch(...)
	{
	}

}

HRESULT ADO_DataBase::CloseConn()
{
	try
	{
		if(m_pConn!= NULL)
			return m_pConn->Close();
		return S_OK;
	}
	catch(_com_error &a_pComError)
	{
		LogCOMExceptions(a_pComError);
		LogProviderExceptions(m_pConn);
		return E_UNEXPECTED;
	}
}

HRESULT ADO_DataBase::CloseRecordSet()
{
	try
	{
		if(m_pRS!= NULL)
			return m_pRS->Close();
		return S_OK;
	}
	catch(_com_error &a_pComError)
	{
		LogCOMExceptions(a_pComError);
		LogProviderExceptions(m_pConn);
		return E_UNEXPECTED;
	}
}

HRESULT ADO_DataBase::SimpleInsertRecord(const char* a_pcTableName,const char* a_pcFirstElement,...)
{
		try
		{
			strcat(m_pQueryString,"INSERT INTO ");
			strcat(m_pQueryString,a_pcTableName);
			strcat(m_pQueryString, " VALUES (");
						
			char *l_pcElement =  (char*)a_pcFirstElement;
			va_list	l_marker;

			va_start(l_marker,a_pcFirstElement);
			
			while(l_pcElement != NULL)
			{
				strcat(m_pQueryString,"'");
				strcat(m_pQueryString, l_pcElement);
				strcat(m_pQueryString,"'");
				strcat(m_pQueryString,",");
				l_pcElement = va_arg(l_marker,char*);
			}
			
			va_end(l_marker);
			char * l_pcLastCommaPos = strrchr(m_pQueryString,',');
			*l_pcLastCommaPos = ')';
			*(l_pcLastCommaPos+1) = 0;
			ExecuteQuery();
			strset(m_pQueryString,0);
			return S_OK;
		}
		catch(_com_error &a_pComError)
		{
			LogCOMExceptions(a_pComError);
			LogProviderExceptions(m_pConn);
			return E_UNEXPECTED;
		}
		catch(...)
		{
			printf("\nError while Inserting Record.");
			return E_UNEXPECTED;
		}
}

/*
HRESULT ADO_DataBase::DeleteAllRecords(const char* a_pcTableName)
{
	try
	{
		strcpy(m_pQueryString,"DELETE ");
		strcat(m_pQueryString,a_pcTableName);
		ExecuteQuery();
		strset(m_pQueryString,0);
		return S_OK;
	}
	catch(...)
	{
		printf("\nError while Deleting Records.");
		return E_UNEXPECTED;
	}
}
*/

HRESULT ADO_DataBase::SimpleCreateTable(const char* a_pcTableName,const char* a_pcFirstElement,...)
{
	try
	{
		strcpy(m_pQueryString,"CREATE TABLE ");
		strcat(m_pQueryString,a_pcTableName);
		strcat(m_pQueryString," (");

		char *l_pcElement =  (char*)a_pcFirstElement;
		va_list	l_marker;

		va_start(l_marker,a_pcFirstElement);
		
		int l_iCount=0;

		while(l_pcElement != NULL)
		{
			l_iCount++;
			strcat(m_pQueryString, l_pcElement);
			strcat(m_pQueryString," ");
			//insert comma after the field type which should come after every second paramater
			//Parameter list should be like "Field1 CHAR(20), Field2 NUMERIC,Field3 VARCHAR(20)"
			if(l_iCount%2==0)
				strcat(m_pQueryString,",");
			
			l_pcElement = va_arg(l_marker,char*);
		}
		
		va_end(l_marker);
		//Replace last comma with ")"
		char * l_pcLastCommaPos = strrchr(m_pQueryString,',');
		*l_pcLastCommaPos = ')';
		*(l_pcLastCommaPos+1) = 0;
		ExecuteQuery();
		strset(m_pQueryString,0);
		return S_OK;
	}
	catch(_com_error &a_pComError)
	{
		LogCOMExceptions(a_pComError);
		LogProviderExceptions(m_pConn);
		return E_UNEXPECTED;
	}
	catch(...)
	{
		printf("\nError while Inserting Record.");
		return E_UNEXPECTED;
	}

}



HRESULT ADO_DataBase::SimpleCreateTable(const char* a_pcTableName,const char a_pcFieldNames[][MAX_FIELD_LENGTH],const long a_lNoOfColumns,const char a_pcFieldTypes[][MAX_FIELD_TYPE_LENGTH])
{
	try
	{
		strcpy(m_pQueryString,"CREATE TABLE ");
		strcat(m_pQueryString,a_pcTableName);
		strcat(m_pQueryString," (");
		
		if(FAILED(BuildCreateTableString(a_pcFieldNames,a_lNoOfColumns,a_pcFieldTypes)))
			return E_UNEXPECTED;

	
		if(ExecuteQuery() == NULL)
		{
			strset(m_pQueryString,0);
			return E_UNEXPECTED;
		}
		strset(m_pQueryString,0);
		return S_OK;
	}
	catch(_com_error &a_pComError)
	{
		LogCOMExceptions(a_pComError);
		LogProviderExceptions(m_pConn);
		return E_UNEXPECTED;
	}
	catch(...)
	{
		printf("\nError while Inserting Record.");
		return E_UNEXPECTED;
	}

}

HRESULT ADO_DataBase::BuildCreateTableString(const char a_pcFieldNames[][MAX_FIELD_LENGTH],const long a_lNoOfColumns,const char a_pcFieldTypes[][MAX_FIELD_TYPE_LENGTH])
{
	try
	{
		for(long l_iIndex = 0;l_iIndex <a_lNoOfColumns;l_iIndex++)
		{
			strcat(m_pQueryString,a_pcFieldNames[l_iIndex]);
			strcat(m_pQueryString," ");
			
			//If the type is not mentioned then CHAR(50) as default
			if(a_pcFieldTypes!= NULL)
				if(a_pcFieldTypes[l_iIndex] != NULL)
					strcat(m_pQueryString,a_pcFieldTypes[l_iIndex]);
				else
					strcat(m_pQueryString,"CHAR(50)");
			else
				strcat(m_pQueryString,"CHAR(50)");
			
			strcat(m_pQueryString,",");

		}
		//Replace last comma with ")"
		char * l_pcLastCommaPos = strrchr(m_pQueryString,',');
		*l_pcLastCommaPos = ')';
		*(l_pcLastCommaPos+1) = 0;

		return S_OK;
	}
	catch(...)
	{
		return E_UNEXPECTED;
	}

}

long ADO_DataBase::GetNoOfColumns(_RecordsetPtr a_pRs)
{
	try
	{
		return a_pRs->Fields->Count;		
	}
	catch(_com_error &a_pComError)
	{
		LogCOMExceptions(a_pComError);
		return 0L;
	}
}


long ADO_DataBase::GetNoOfColumns()
{
	try
	{
		return m_pRS->Fields->Count;		
	}
	catch(_com_error &a_pComError)
	{
		LogCOMExceptions(a_pComError);
		return 0L;
	}
}


HRESULT ADO_DataBase::GetColumnNames(_RecordsetPtr a_pRs,char a_pcColumNames[][MAX_FIELD_LENGTH],char a_pcColumnTypes[][MAX_FIELD_TYPE_LENGTH])
{
	try
	{
		_variant_t l_vaIndex;
		l_vaIndex.vt = VT_I2;
		long l_lNoOfColumns;
		l_lNoOfColumns = GetNoOfColumns(a_pRs);
		char l_pcColumnType[MAX_FIELD_TYPE_LENGTH];

		
		for(int l_iIndex = 0 ;l_iIndex < l_lNoOfColumns;l_iIndex++)
		{
			l_vaIndex.iVal = l_iIndex;
			sprintf(a_pcColumNames[l_iIndex],"%s",(LPSTR)a_pRs->Fields->GetItem(l_vaIndex)->Name);
			memset(l_pcColumnType,0,sizeof(char)*MAX_FIELD_TYPE_LENGTH);
			ParseColumnTypes(m_pRS->Fields->GetItem(l_vaIndex)->Type,l_pcColumnType);
			sprintf(a_pcColumnTypes[l_iIndex],"%s",l_pcColumnType);
		}
		
		return S_OK;
	}
	catch(_com_error &a_pComError)
	{
		LogCOMExceptions(a_pComError);
		return E_UNEXPECTED;
	}
	catch(...)
	{
		printf("\nError Retrieving Column Names.\n");
		return E_UNEXPECTED;
	}
}


HRESULT ADO_DataBase::GetColumnNames(char a_pcColumNames[][MAX_FIELD_LENGTH],char a_pcColumnTypes[][MAX_FIELD_TYPE_LENGTH])
{
	try
	{
		_variant_t l_vaIndex;
		l_vaIndex.vt = VT_I2;
		long l_lNoOfColumns;
		l_lNoOfColumns = GetNoOfColumns(m_pRS);
		char l_pcColumNames[MAX_FIELD_LENGTH];

		for(int l_iIndex = 0 ;l_iIndex < l_lNoOfColumns;l_iIndex++)
		{
			l_vaIndex.iVal = l_iIndex;
			strcpy(l_pcColumNames,m_pRS->Fields->GetItem(l_vaIndex)->Name);
			/*
			//Convert any blanks and special characters in the column names to '_'
			int l_iCount = 0;
			while(l_pcColumNames[l_iCount] != '\0')
			{
				
				if(!isalpha(l_pcColumNames[l_iCount]))
				{
					l_pcColumNames[l_iCount] = '_';
				}
				l_iCount++;
			}*/
			sprintf(a_pcColumNames[l_iIndex],"%s",l_pcColumNames);
			ParseColumnTypes(m_pRS->Fields->GetItem(l_vaIndex)->Type,a_pcColumnTypes[l_iIndex]);
		}
		return S_OK;
	}
	catch(_com_error &a_pComError)
	{
		LogCOMExceptions(a_pComError);
		return E_UNEXPECTED;
	}
	catch(...)
	{
		printf("\nError Retrieving Column Names.\n");
		return E_UNEXPECTED;
	}
}

HRESULT ADO_DataBase::GetProperties(_RecordsetPtr a_pRs,int a_iProperty[100])
{
	try
	{
		_variant_t l_vaIndex;
		l_vaIndex.vt = VT_I2;
		
		for(int l_iIndex = 0 ;l_iIndex < a_pRs->Properties->GetCount();l_iIndex++)
		{
			l_vaIndex.iVal = l_iIndex;
			a_iProperty[l_iIndex] = a_pRs->Fields->GetItem(l_vaIndex)->Properties->Count;
			//a_iProperty[l_iIndex] = (int)(a_pRs->Properties->GetItem(l_vaIndex))->GetType();
			
		}
		
		return S_OK;
	}
	catch(_com_error &a_pComError)
	{
		LogCOMExceptions(a_pComError);
		return E_UNEXPECTED;
	}
	catch(...)
	{
		printf("\nError Retrieving Column Names.\n");
		return E_UNEXPECTED;
	}
}


HRESULT ADO_DataBase::GetOneRow(_RecordsetPtr a_pRs,const long a_lNoOfColumns,_variant_t a_varValue[])
{
	try
	{
		
		_variant_t l_vaIndex;
		l_vaIndex.vt = VT_I2;
		
		//All the values are stored inside a_bstrValue as a string
		for(long l_lIndex = 0;l_lIndex<a_lNoOfColumns;l_lIndex++)
		{ 
			l_vaIndex.iVal = l_lIndex;
			a_varValue[l_lIndex] = a_pRs->Fields->GetItem(l_vaIndex)->Value;
		}
		
		return S_OK;
	}
	catch(_com_error &a_pComError)
	{
		LogCOMExceptions(a_pComError);
		return E_UNEXPECTED;
	}
	catch(...)
	{
		printf("\nError Retrieving Column Names.\n");
		return E_UNEXPECTED;
	}
}

HRESULT ADO_DataBase::GetOneRow(const long a_lNoOfColumns,_variant_t a_varValue[])
{
	try
	{
		
		_variant_t l_vaIndex;
		l_vaIndex.vt = VT_I2;
		
		//All the values are stored inside a_bstrValue as a string
		for(long l_lIndex = 0;l_lIndex<a_lNoOfColumns;l_lIndex++)
		{ 
			l_vaIndex.iVal = l_lIndex;
			a_varValue[l_lIndex] = m_pRS->Fields->GetItem(l_vaIndex)->Value;
		}
		
		return S_OK;
	}
	catch(_com_error &a_pComError)
	{
		LogCOMExceptions(a_pComError);
		return E_UNEXPECTED;
	}
	catch(...)
	{
		printf("\nError Retrieving Column Names.\n");
		return E_UNEXPECTED;
	}
}


HRESULT ADO_DataBase::InsertAllRows(const char*a_pcTableName,_RecordsetPtr a_pRs,const long a_lNoOfColumns,_variant_t a_varValue[])
{
	try
	{
		//a_pRs is the recordset from where data is to be inserted 
		//i.e. the source recordset
		
		a_pRs->MoveFirst();
		
		if(a_pRs->EndOfFile)
		{
			printf("\nRecordset Empty\n");
		}
		else
		{
			while(!a_pRs->EndOfFile)
			{
				GetOneRow(a_pRs,a_lNoOfColumns,a_varValue);
				SimpleInsertRecord(a_pcTableName,a_lNoOfColumns,a_varValue);
				a_pRs->MoveNext();
			}
		}
		return S_OK;
	}
	catch(_com_error &a_pComError)
	{
		LogCOMExceptions(a_pComError);
		return E_UNEXPECTED;
	}
	catch(...)
	{
		m_LogFile.WriteToLogFile("\nError While Inserting Rows");
		printf("\nError While Inserting Rows.\n");
		return E_UNEXPECTED;
	}
}


HRESULT ADO_DataBase::SimpleInsertRecord(const char* a_pcTableName,const long a_lNoOfColumns,_variant_t* a_varValue)
{
		try
		{
			strcat(m_pQueryString,"INSERT INTO ");
			strcat(m_pQueryString,a_pcTableName);
			strcat(m_pQueryString, " VALUES (");
						
			if(FAILED(BuildInsertRecordString(a_lNoOfColumns,a_varValue)))
				return E_UNEXPECTED;

			ExecuteQuery();
			strset(m_pQueryString,0);
			return S_OK;
		}
		catch(_com_error &a_pComError)
		{
			LogCOMExceptions(a_pComError);
			LogProviderExceptions(m_pConn);
			return E_UNEXPECTED;
		}
		catch(...)
		{
			printf("\nError while Inserting Record.");
			return E_UNEXPECTED;
		}
}


HRESULT ADO_DataBase::BuildInsertRecordString(const long a_lNoOfColumns,_variant_t a_varValue[])
{
	try
	{
		for(long l_lCount = 0;l_lCount <a_lNoOfColumns ;l_lCount++)
		{
			strcat(m_pQueryString,"'");
			//While creating the string treat everything as a string
			a_varValue[l_lCount];
			//If the field value is Null replace with a space
			if(a_varValue[l_lCount].vt == VT_NULL)
				strcat(m_pQueryString,"");
			else
				strcat(m_pQueryString, (char*)(_bstr_t)(a_varValue[l_lCount]));
			strcat(m_pQueryString,"'");
			strcat(m_pQueryString,",");
		}
		char * l_pcLastCommaPos = strrchr(m_pQueryString,',');
		*l_pcLastCommaPos = ')';
		*(l_pcLastCommaPos+1) = 0;
		return S_OK;
	}
	catch(...)
	{
		m_LogFile.WriteToLogFile("\nError while building Insert Record String");
		printf("\nError while building Insert Record String.");
		return E_UNEXPECTED;
	}
}


void ADO_DataBase::ParseColumnTypes(DataTypeEnum a_DataType, char* l_pcColumnType)
{
	try
	{
		switch (a_DataType)
		{
		  //case adEmpty: 
			case adTinyInt:strcpy(l_pcColumnType,"TINYINT");break;
			case adSmallInt:strcpy(l_pcColumnType,"SMALLINT");break;
			case adInteger:strcpy(l_pcColumnType,"INT");break;
			case adBigInt:strcpy(l_pcColumnType,"BIGINT");break;
			case adUnsignedTinyInt:strcpy(l_pcColumnType,"TINYINT");break;
			case adUnsignedSmallInt:strcpy(l_pcColumnType,"SMALLINT");break;
			case adUnsignedInt:strcpy(l_pcColumnType,"INT");break;
			case adUnsignedBigInt:strcpy(l_pcColumnType,"BIGINT");break;
			case adSingle:strcpy(l_pcColumnType,"FLOAT");break;
			case adDouble:strcpy(l_pcColumnType,"FLOAT");break;
			//case adCurrency:
			case adDecimal:strcpy(l_pcColumnType,"DECIMAL(20,5)");break;
			case adNumeric:strcpy(l_pcColumnType,"NUMERIC(20)");break;
			case adBoolean:strcpy(l_pcColumnType,"INT");break;
			//case adError:
			//case adUserDefined:
			//case adVariant:
			//case adIDispatch:
			//case adIUnknown:
			//case adGUID:
			case adDate:strcpy(l_pcColumnType,"DATE");break;
			case adDBDate:strcpy(l_pcColumnType,"DATE");break;
			case adDBTime:strcpy(l_pcColumnType,"DATETIME");break;
			case adDBTimeStamp:strcpy(l_pcColumnType,"DATETIME");break;
			case adBSTR: strcpy(l_pcColumnType,"CHAR(50)");break;
			case adChar: strcpy(l_pcColumnType,"CHAR(50)");break;
			case adVarChar:strcpy(l_pcColumnType,"VARCHAR(50)");break;
			case adLongVarChar:strcpy(l_pcColumnType,"VARCHAR(50)");break;
			//case adWChar:
			//case adVarWChar:
			//case adLongVarWChar:
			case adBinary:strcpy(l_pcColumnType,"BINARY(50)");break;
			case adVarBinary:strcpy(l_pcColumnType,"VARBINARY(50)");break;
			//case adLongVarBinary:
			//case adChapter:
			//case adFileTime:
			//case adPropVariant:
			//case adVarNumeric:
			//case adArray:
		default:strcpy(l_pcColumnType,"CHAR(50)");break;
		}
	}
	catch(...)
	{
		printf("\nError while retrieving column types\n");
	}
}