#if !defined __ADO_DATABASE
#define __ADO_DATABASE

#define MAX_FIELD_LENGTH 255
#define MAX_FIELD_TYPE_LENGTH 50

#import "C:\Program Files\Common Files\System\ADO\msado15.dll" \
    no_namespace rename("EOF", "EndOfFile")

#include "stdio.h"
#include "LogFile.h"
#include <vector>

using namespace std;

class ADO_DataBase
{
protected:
	static LogFile m_LogFile;
	_RecordsetPtr m_pRS;
	_ConnectionPtr m_pConn;
	//_CommandPtr m_pComm;
	char m_pConnString[512];
	char m_pUserId[256];
	char m_pUserPassword[256];
	char m_pQueryString[2048];
	char m_pProvider[256];
	char m_pDataSource[MAX_PATH];
	char m_pInitialCatalog[256];
	char m_pExtendedProperties[256];
	ConnectOptionEnum m_ConnectOption;
	CursorTypeEnum m_CursorType;
	LockTypeEnum	m_LockType;
	long m_lOptions;
	
	HRESULT BuildCreateTableString(const char a_pchColumnNames[][MAX_FIELD_LENGTH],const long a_lNoOfCols,const char ColumnTypes[][MAX_FIELD_TYPE_LENGTH]);
	HRESULT BuildInsertRecordString(const long,_variant_t* a_varOneRowData);
	void ParseColumnTypes(DataTypeEnum a_DataTypes,char* l_pchColumnType);
public:
	//ADO_DataBase();
	virtual ~ADO_DataBase();
	
	HRESULT Init();

	void SetUserId(const char* a_pchUserIdString);
	void SetUserPassword(const char* a_pchUserPasswordString);
	void SetQueryString(const char* a_pchQueryString);
	void SetProvider(const char* a_pchProviderString);
	void SetDataSource(const char* a_DataSourceString);
	void SetInitialCatalog(const char* a_pchIntitalCatalogString);
	void SetExtendedProperties(const char* a_pchExtendedPrpoertiesString);

	void SetCursorType(CursorTypeEnum a_CursorType);
	void SetLockType(LockTypeEnum a_LockType);
	void SetOpenRecordSetOptions(long a_lOpenRecordsetOptions);

	void SetConnString(const char* a_pchConnString);
	void SetConnectionTimeOut(const int a_iConnTimeOut);
	char* BuildConnString();
	void SetConnectOption(ConnectOptionEnum a_ConnectOption);
	HRESULT ConnectToDB();
	
	_RecordsetPtr GetRecordSet();
	void PrintRecordSet(const long a_lNoOfRecords) ;//printing to console for debugging purposes
	
	_RecordsetPtr ExecuteQuery();//executes the m_pQueryString
	_RecordsetPtr ExecuteQuery(char* a_pchQueryString);//executes the given query string

	HRESULT GetColumnNames(_RecordsetPtr a_pRs,char a_pchColumnName[][MAX_FIELD_LENGTH],char a_pchColumnType[][MAX_FIELD_TYPE_LENGTH]);
	HRESULT GetColumnNames(char a_pchColumnName[][MAX_FIELD_LENGTH],char a_pchColumnType[][MAX_FIELD_TYPE_LENGTH]);

	long GetNoOfColumns(_RecordsetPtr a_pRs);
	long GetNoOfColumns();
	
	HRESULT GetProperties(_RecordsetPtr a_pRs,int* a_iProperties);
	
	HRESULT GetOneRow(_RecordsetPtr a_pRs,const long a_lNoOfColumns,_variant_t* a_varOneRowData);
	HRESULT GetOneRow(const long a_lNoOfColumns,_variant_t* a_varOneRowData);

	HRESULT InsertAllRows(const char* a_pchTableName,_RecordsetPtr a_pSourceRs,const long a_lNoOfColumns,_variant_t* a_varOneRowData);
	
	HRESULT SimpleInsertRecord(const char* a_pchTableName,const char* a_pchColumns,...);//TableName,fields1,...
	HRESULT SimpleInsertRecord(const char* a_pchTableName,const long a_lNoOfCols,_variant_t* a_varOneRowData);
	
	//HRESULT DeleteAllRecords(const char*);//TableName
	HRESULT SimpleCreateTable(const char* a_pchTableName,const char* a_pchColumnName,...);//TableName,column name,column type,...
	HRESULT SimpleCreateTable(const char* a_pchTableName,const char a_pchColumnName[][MAX_FIELD_LENGTH],const long a_lNoOfCols,const char a_pchColumnType[][MAX_FIELD_TYPE_LENGTH]);//TableName,column name,column type,...
	
	//void SaveRecordSetinXML(char[MAX_PATH]);//filename
	
	void LogCOMExceptions(_com_error& a_refComError);
	void LogProviderExceptions(_ConnectionPtr a_ConPtrError);
	
	HRESULT CloseConn();
	HRESULT CloseRecordSet();

};

#endif