#include "ADO_DataBase_Excel.h"
#include "stdio.h"
#include "stdlib.h"

HRESULT ADO_DataBase_Excel::Init()
{
	if(FAILED(ADO_DataBase::Init()))
		return E_UNEXPECTED;
	SetExtendedProperties("Excel 8.0");
	SetProvider("Microsoft.Jet.OLEDB.4.0");
	return S_OK;
};

char* ADO_DataBase_Excel::BuildConnString()
{
	try
	{
		sprintf(m_pConnString,"Provider=%s;Data Source=%s;Extended Properties = %s;User Id=%s;Password=%s;",\
			m_pProvider,m_pDataSource,m_pExtendedProperties,m_pUserId,m_pUserPassword);
		return m_pConnString;
	}
	catch(...)
	{
		printf("Fatal Error!!\nConnection String cannot be built!!");
		return NULL;
		//exit(0);
	}
}

HRESULT ADO_DataBase_Excel::SimpleInsertRecord(const char* a_pcTableName,const char* a_pcFirstElement,...)
{
		try
		{
			strcat(m_pQueryString,"INSERT INTO [");
			strcat(m_pQueryString,a_pcTableName);
			strcat(m_pQueryString,"$]");
			strcat(m_pQueryString, " VALUES (");
			
			int l_iCount =0;
			char *l_pcElement =  (char*)a_pcFirstElement;
			va_list	l_marker;

			va_start(l_marker,a_pcFirstElement);
			
	
			while(l_pcElement != NULL)
			{
				
				strcat(m_pQueryString,"'");
				strcat(m_pQueryString, l_pcElement);
				strcat(m_pQueryString,"'");
				strcat(m_pQueryString,",");
				l_pcElement = va_arg(l_marker,char*);
			}
			
			va_end(l_marker);
			char * l_pcLastCommaPos = strrchr(m_pQueryString,',');
			*l_pcLastCommaPos = ')';
			*(l_pcLastCommaPos+1) = 0;
			ExecuteQuery();
			strset(m_pQueryString,0);
			return S_OK;
		}
		catch(...)
		{
			printf("\nError while Inserting Record.");
			return E_UNEXPECTED;
		}
}

/*
HRESULT ADO_DataBase_Excel::DeleteAllRecords(const char* a_pcTableName)
{
	try
	{
		strcpy(m_pQueryString,"DELETE [");
		strcat(m_pQueryString,a_pcTableName);
		strcat(m_pQueryString,"$]");
		ExecuteQuery();
		strset(m_pQueryString,0);
		return S_OK;
	}
	catch(...)
	{
		printf("\nError while Deleting Records.");
		return S_FALSE;
	}
}
*/

HRESULT ADO_DataBase_Excel::SimpleCreateTable(const char* a_pcTableName,const char* a_pcFirstElement,...)
{
	try
	{
		strcpy(m_pQueryString,"CREATE TABLE [");
		strcat(m_pQueryString,a_pcTableName);
		strcat(m_pQueryString,"] (");

		char *l_pcElement =  (char*)a_pcFirstElement;
		va_list	l_marker;

		va_start(l_marker,a_pcFirstElement);
		
		int l_iCount=0;

		while(l_pcElement != NULL)
		{
			l_iCount++;
			strcat(m_pQueryString, l_pcElement);
			strcat(m_pQueryString," ");

			if(l_iCount%2==0)
				strcat(m_pQueryString,",");
			
			l_pcElement = va_arg(l_marker,char*);
			
		}
		
		va_end(l_marker);
		char * l_pcLastCommaPos = strrchr(m_pQueryString,',');
		*l_pcLastCommaPos = ')';
		*(l_pcLastCommaPos+1) = 0;
		if(IsFileOpen())
		{
			printf("Please close the %s before proceeding",m_pDataSource);
			return E_UNEXPECTED;
		}
		ExecuteQuery();
		strset(m_pQueryString,0);
		return S_OK;
	}
	catch(_com_error &a_pComError)
	{
		LogCOMExceptions(a_pComError);
		LogProviderExceptions(m_pConn);
		return E_UNEXPECTED;
	}
	catch(...)
	{
		printf("\nError while Inserting Record.");
		return E_UNEXPECTED;
	}

}


HRESULT ADO_DataBase_Excel::SimpleCreateTable(const char* a_pcTableName,const char a_pcFieldNames[][MAX_FIELD_LENGTH],const long a_lNoOfColumns,const char a_pcFieldTypes[][MAX_FIELD_TYPE_LENGTH])
{
	try
	{
		strcpy(m_pQueryString,"CREATE TABLE [");
		strcat(m_pQueryString,a_pcTableName);
		strcat(m_pQueryString,"] (");
		
		if(FAILED(BuildCreateTableString(a_pcFieldNames,a_lNoOfColumns,a_pcFieldTypes)))
			return E_UNEXPECTED;

		if(IsFileOpen())
		{
			printf("Please close the %s before proceeding",m_pDataSource);
			return E_UNEXPECTED;
		}
		if(ExecuteQuery()== NULL)
		{
			strset(m_pQueryString,0);
			return E_UNEXPECTED;
		}
		strset(m_pQueryString,0);
		return S_OK;
	}
	catch(_com_error &a_pComError)
	{
		LogCOMExceptions(a_pComError);
		LogProviderExceptions(m_pConn);
		return E_UNEXPECTED;
	}
	catch(...)
	{
		printf("\nError while Inserting Record.");
		return E_UNEXPECTED;
	}

}

HRESULT ADO_DataBase_Excel::InsertAllRows(const char* a_pcTableName,_RecordsetPtr a_pRs,const long a_lNoOfColumns,_variant_t a_varValue[])
{
	try
	{
		
		a_pRs->MoveFirst();
		
		if(a_pRs->EndOfFile)
		{
			printf("\nRecordset Empty\n");
		}
		else
		{
			if(IsFileOpen())
			{
				printf("Please close the %s before proceeding",m_pDataSource);
				return E_UNEXPECTED;
			}
			//Have to check if the file is already open. If so print
			// an error and exit
			while(!a_pRs->EndOfFile)
			{
				GetOneRow(a_pRs,a_lNoOfColumns,a_varValue);
				SimpleInsertRecord(a_pcTableName,a_lNoOfColumns,a_varValue);
				a_pRs->MoveNext();
			}
		}
		return S_OK;
	}
	catch(_com_error &a_pComError)
	{
		LogCOMExceptions(a_pComError);
		return E_UNEXPECTED;
	}
	catch(...)
	{
		printf("\nError Retrieving Column Names.\n");
		return E_UNEXPECTED;
	}
}

HRESULT ADO_DataBase_Excel::SimpleInsertRecord(const char* a_pcTableName,const long a_lNoOfColumns,_variant_t a_varValue[])
{
		try
		{
			strcat(m_pQueryString,"INSERT INTO ");
			strcat(m_pQueryString,a_pcTableName);
			strcat(m_pQueryString, " VALUES (");
						
			if(FAILED(BuildInsertRecordString(a_lNoOfColumns,a_varValue)))
				return E_UNEXPECTED;

			if(ExecuteQuery()== NULL)
			{
				strset(m_pQueryString,0);
				return E_UNEXPECTED;
			}
			strset(m_pQueryString,0);
			return S_OK;
		}
		catch(_com_error &a_pComError)
		{
			LogCOMExceptions(a_pComError);
			//LogProviderExceptions(m_pConn);
			return E_UNEXPECTED;
		}
		catch(...)
		{
			printf("\nError while Inserting Record.");
			return E_UNEXPECTED;
		}
}


BOOL ADO_DataBase_Excel::IsFileOpen(const char* a_pcFileName) const
{
	try
	{
		HANDLE l_hFile;
		//The file is opened with no sharing given
		l_hFile = CreateFile(a_pcFileName,GENERIC_READ,0,NULL,OPEN_EXISTING,0,NULL);
		if(INVALID_HANDLE_VALUE == l_hFile)
		{
			if(ERROR_SHARING_VIOLATION == GetLastError())
				return TRUE; // The file is already open
			return FALSE;
		}
		CloseHandle(l_hFile);
		return FALSE;
	}
	catch(...)
	{
		printf("\nFatal Error\n");
		return FALSE;
	}
}


BOOL ADO_DataBase_Excel::IsFileOpen() const
{
	//Have to be changed later..
	return FALSE;
	//////
	try
	{
		HANDLE l_hFile;
		//The file is opened with no sharing given
		l_hFile = CreateFile(m_pDataSource,GENERIC_READ,0,NULL,OPEN_EXISTING,0,NULL);
		if(INVALID_HANDLE_VALUE == l_hFile)
		{
			if(ERROR_SHARING_VIOLATION == GetLastError())
				return TRUE; // The file is already open
			return FALSE;
		}
		CloseHandle(l_hFile);
		return FALSE;
	}
	catch(...)
	{
		printf("\nFatal Error\n");
		return FALSE;
	}
}

char* ADO_DataBase_Excel::SetWKSorRNGName(char *a_pchTableName,BOOL a_bWKS_OR_RNG)
{
	try
	{
		char l_pchTemp[260];
		strcpy(l_pchTemp,"[");
		if(a_bWKS_OR_RNG == RANGE)
		{
			strcat(l_pchTemp,a_pchTableName);
			strcat(l_pchTemp,"]");
			strcpy(a_pchTableName,l_pchTemp);
			return a_pchTableName;
		}
		else
		{
			if(a_bWKS_OR_RNG == WORKSHEET)
			{
				strcat(l_pchTemp,a_pchTableName);
				strcat(l_pchTemp,"$]");
				strcpy(a_pchTableName,l_pchTemp);
				return a_pchTableName;
			}
		}
		return NULL;
	}
	catch(...)
	{
		m_LogFile.WriteToLogFile("\nError while distinguishing between a Worksheet and a Range");
		return NULL;
	}
}