// Sample3_GUI.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include "resource.h"
#include "commdlg.h"
#include "commctrl.h"
#include "ADO_DataBase_Excel.h"
#include "ADO_DataBase_SQLServer.h"
#include "string.h"

#define MAX_LOADSTRING 100

// Global Variables:
HINSTANCE hInst;								// current instance
TCHAR szTitle[MAX_LOADSTRING];								// The title bar text
TCHAR szWindowClass[MAX_LOADSTRING];								// The title bar text

// Foward declarations of functions included in this code module:
ATOM				MyRegisterClass(HINSTANCE hInstance);
BOOL				InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK	About(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK	DlgMainProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK XLTOSQLProc(HWND , UINT , WPARAM , LPARAM );
LRESULT CALLBACK SQLTOXLProc(HWND , UINT , WPARAM , LPARAM );


void InitOpenSaveFileName(LPOPENFILENAME,HWND);
void InitOpenFileName(LPOPENFILENAME,HWND);
void InitSaveFileName(LPOPENFILENAME,HWND);
BOOL IsContainInvalidChars(const TCHAR*);

TCHAR l_pchServerName[256];//DataSource Name
TCHAR l_pchDataBaseName[256];//Initial Catalog
TCHAR l_pchUserName[256];
TCHAR l_pchXLFilePath[MAX_PATH];
TCHAR l_pchPassword[256];
TCHAR l_pchXL_WKS_Name[MAX_PATH];//Worksheet or Range name 
																//from where to read data
TCHAR l_pchSQL_Table_Name[256];//Table name in SQL Server where to 
															 //store data
TCHAR l_pchQueryString[1024];


int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{
 	// TODO: Place code here.
	MSG msg;
	HACCEL hAccelTable;

	// Initialize global strings
	LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);
	LoadString(hInstance, IDC_SAMPLE3_GUI, szWindowClass, MAX_LOADSTRING);
	MyRegisterClass(hInstance);

	// Perform application initialization:
	if (!InitInstance (hInstance, nCmdShow)) 
	{
		return FALSE;
	}

	hAccelTable = LoadAccelerators(hInstance, (LPCTSTR)IDC_SAMPLE3_GUI);

	// Main message loop:
	while (GetMessage(&msg, NULL, 0, 0)) 
	{
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg)) 
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	return msg.wParam;
}



//
//  FUNCTION: MyRegisterClass()
//
//  PURPOSE: Registers the window class.
//
//  COMMENTS:
//
//    This function and its usage is only necessary if you want this code
//    to be compatible with Win32 systems prior to the 'RegisterClassEx'
//    function that was added to Windows 95. It is important to call this function
//    so that the application will get 'well formed' small icons associated
//    with it.
//
ATOM MyRegisterClass(HINSTANCE hInstance)
{
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX); 

	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= (WNDPROC)WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= LoadIcon(hInstance, (LPCTSTR)IDI_SAMPLE3_GUI);
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszMenuName	= (LPCSTR)IDC_SAMPLE3_GUI;
	wcex.lpszClassName	= szWindowClass;
	wcex.hIconSm		= LoadIcon(wcex.hInstance, (LPCTSTR)IDI_SMALL);

	return RegisterClassEx(&wcex);
}

//
//   FUNCTION: InitInstance(HANDLE, int)
//
//   PURPOSE: Saves instance handle and creates main window
//
//   COMMENTS:
//
//        In this function, we save the instance handle in a global variable and
//        create and display the main program window.
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
   HWND hWnd;

   hInst = hInstance; // Store instance handle in our global variable
	 memset(l_pchServerName,0,256);
	 memset(l_pchDataBaseName,0,256);
	 memset(l_pchUserName,0,256);
	 memset(l_pchXLFilePath,0,MAX_PATH);
	 memset(l_pchPassword,0,256);
	 memset(l_pchXL_WKS_Name,0,256);
	 memset(l_pchSQL_Table_Name,0,256);
   memset(l_pchQueryString,0,1024);

   hWnd = CreateWindow(szWindowClass, szTitle, WS_OVERLAPPEDWINDOW,
      CW_USEDEFAULT, 0, CW_USEDEFAULT, 0, NULL, NULL, hInstance, NULL);

   if (!hWnd)
   {
      return FALSE;
   }

   ShowWindow(hWnd, nCmdShow);
   UpdateWindow(hWnd);

   return TRUE;
}

//
//  FUNCTION: WndProc(HWND, unsigned, WORD, LONG)
//
//  PURPOSE:  Processes messages for the main window.
//
//  WM_COMMAND	- process the application menu
//  WM_PAINT	- Paint the main window
//  WM_DESTROY	- post a quit message and return
//
//
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent;
	PAINTSTRUCT ps;
	HDC hdc;
	TCHAR szHello[MAX_LOADSTRING];
	LoadString(hInst, IDS_HELLO, szHello, MAX_LOADSTRING);

	switch (message) 
	{
		//case WM_SIZE:
			//DialogBox(hInst, (LPCTSTR)IDD_DIALOG_MAIN, hWnd, (DLGPROC)DlgMainProc);
			//return 0;
		case WM_COMMAND:
			wmId    = LOWORD(wParam); 
			wmEvent = HIWORD(wParam); 
			// Parse the menu selections:
			switch (wmId)
			{
				case IDM_XLTOSQL:
				   DialogBox(hInst, (LPCTSTR)IDD_DIALOG_XLTOSQL, hWnd, (DLGPROC)XLTOSQLProc);
				   break;
				case IDM_SQLTOXL:
				   DialogBox(hInst, (LPCTSTR)IDD_DIALOG_SQLTOXL, hWnd, (DLGPROC)SQLTOXLProc);
				   break;
				case IDM_ABOUT:
				   DialogBox(hInst, (LPCTSTR)IDD_ABOUTBOX, hWnd, (DLGPROC)About);
				   break;
				case IDM_EXIT:
				   DestroyWindow(hWnd);
				   break;
				default:
				   return DefWindowProc(hWnd, message, wParam, lParam);
			}
			break;
		case WM_PAINT:
			hdc = BeginPaint(hWnd, &ps);
			// TODO: Add any drawing code here...
			RECT rt;
			GetClientRect(hWnd, &rt);
			DrawText(hdc, szHello, strlen(szHello), &rt, DT_CENTER);
			EndPaint(hWnd, &ps);
			break;
		case WM_DESTROY:
			PostQuitMessage(0);
			break;
		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
   }
   return 0;
}
LRESULT CALLBACK	DlgMainProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
	{
		case WM_INITDIALOG:
				return TRUE;

		case WM_COMMAND:
			switch((LOWORD(wParam)))
			{
				case IDCANCEL:
				case IDOK:
					 EndDialog(hDlg, LOWORD(wParam));
					 return TRUE;
				case IDC_BUTTON_XLTOSQL:
				   DialogBox(hInst, (LPCTSTR)IDD_DIALOG_XLTOSQL, hDlg, (DLGPROC)XLTOSQLProc);
				   break;
				case IDC_BUTTON_SQLTOXL:
					 DialogBox(hInst, (LPCTSTR)IDD_DIALOG_SQLTOXL, hDlg, (DLGPROC)SQLTOXLProc);
				   break;
			}
			break;
	}
   return FALSE;
}

// Mesage handler for about box.
LRESULT CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
	{
		case WM_INITDIALOG:
				return TRUE;

		case WM_COMMAND:
			if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL) 
			{
				EndDialog(hDlg, LOWORD(wParam));
				return TRUE;
			}
			break;
	}
    return FALSE;
}


LRESULT CALLBACK XLTOSQLProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	
	switch (message)
	{
		case WM_INITDIALOG:
			{
				if(strlen(l_pchServerName) == 0)
					SendDlgItemMessage(hDlg,IDC_EDIT_SERVERNAME_XLTOSQL,WM_SETTEXT,0,(LPARAM)"SERVER");
				else
					SendDlgItemMessage(hDlg,IDC_EDIT_SERVERNAME_XLTOSQL,WM_SETTEXT,0,(LPARAM)l_pchServerName);
				if(strlen(l_pchDataBaseName) == 0)
					SendDlgItemMessage(hDlg,IDC_EDIT_DATABASENAME_XLTOSQL,WM_SETTEXT,0,(LPARAM)"pubs");
				else
					SendDlgItemMessage(hDlg,IDC_EDIT_DATABASENAME_XLTOSQL,WM_SETTEXT,0,(LPARAM)l_pchDataBaseName);
				if(strlen(l_pchUserName) == 0)
					SendDlgItemMessage(hDlg,IDC_EDIT_USERNAME_XLTOSQL,WM_SETTEXT,0,(LPARAM)"sa");
				else
					SendDlgItemMessage(hDlg,IDC_EDIT_USERNAME_XLTOSQL,WM_SETTEXT,0,(LPARAM)l_pchUserName);

				SendDlgItemMessage(hDlg,IDC_EDIT_PASSWORD_XLTOSQL,WM_SETTEXT,0,(LPARAM)"");
				
				SendDlgItemMessage(hDlg,IDC_RADIO_WKS_XLTOSQL,BM_SETCHECK,BST_CHECKED,0);
				SendDlgItemMessage(hDlg,IDC_RADIO_RNG_XLTOSQL,BM_SETCHECK,BST_UNCHECKED,0);
				
				return TRUE;
			}

		case WM_COMMAND:
			switch((LOWORD(wParam)))
			{
				case IDOK:
				case IDCANCEL: 
					{
						EndDialog(hDlg, LOWORD(wParam));
						return TRUE;
					}
				case IDC_BUTTON_LOCATE_XLTOSQL:
					{
						OPENFILENAME l_OpenFileName;
						//InitOpenFileName(&l_OpenFileName,hDlg);
						
						//Initialize the OPENFILENAME structure
						memset(&l_OpenFileName,0,sizeof(OPENFILENAME));
						l_OpenFileName.lStructSize = sizeof(OPENFILENAME);
						l_OpenFileName.hwndOwner = hDlg;
						l_OpenFileName.hInstance = NULL;
						l_OpenFileName.lpstrFilter = "Excel Files\0*.xls\0All\0*.*\0";
						l_OpenFileName.lpstrCustomFilter = NULL;
						l_OpenFileName.nFilterIndex = 0;
						l_OpenFileName.lpstrFile = new TCHAR[MAX_PATH];
						memset(l_OpenFileName.lpstrFile,0,MAX_PATH);
						l_OpenFileName.nMaxFile = MAX_PATH-1;
						l_OpenFileName.lpstrFileTitle = new TCHAR[MAX_PATH];
						memset(l_OpenFileName.lpstrFileTitle,0,MAX_PATH);
						l_OpenFileName.nMaxFileTitle = MAX_PATH -1;
						l_OpenFileName.lpstrInitialDir = NULL;
						l_OpenFileName.lpstrTitle = "Choose Excel File";
						l_OpenFileName.Flags = OFN_EXPLORER|OFN_PATHMUSTEXIST|OFN_FILEMUSTEXIST|OFN_SHOWHELP;
						l_OpenFileName.lpstrDefExt = NULL;
						
						GetOpenFileName(&l_OpenFileName);
						SendDlgItemMessage(hDlg,IDC_EDIT_FILEPATH_XLTOSQL,WM_SETTEXT,0,(LPARAM)l_OpenFileName.lpstrFile);
						
						DWORD err = CommDlgExtendedError();
						break;
					}
				case IDC_BUTTON_MIGRATE_XLTOSQL:
					{
						try
						{
						
						//Gather all the data
						SendDlgItemMessage(hDlg,IDC_EDIT_SERVERNAME_XLTOSQL,WM_GETTEXT,256,(LPARAM)l_pchServerName);
						SendDlgItemMessage(hDlg,IDC_EDIT_DATABASENAME_XLTOSQL,WM_GETTEXT,256,(LPARAM)l_pchDataBaseName);
						SendDlgItemMessage(hDlg,IDC_EDIT_USERNAME_XLTOSQL,WM_GETTEXT,256,(LPARAM)l_pchUserName);
						SendDlgItemMessage(hDlg,IDC_EDIT_PASSWORD_XLTOSQL,WM_GETTEXT,256,(LPARAM)l_pchPassword);
						SendDlgItemMessage(hDlg,IDC_EDIT_FILEPATH_XLTOSQL,WM_GETTEXT,MAX_PATH,(LPARAM)l_pchXLFilePath);
						SendDlgItemMessage(hDlg,IDC_EDIT_XL_WKS_NAME,WM_GETTEXT,MAX_PATH,(LPARAM)l_pchXL_WKS_Name);
						SendDlgItemMessage(hDlg,IDC_EDIT_TABLE_NAME,WM_GETTEXT,MAX_PATH,(LPARAM)l_pchSQL_Table_Name);
						
						//Validate Input
						if((l_pchServerName == NULL || strlen(l_pchServerName) == 0)||\
							(l_pchDataBaseName == NULL || strlen(l_pchDataBaseName) == 0)||\
							(l_pchUserName == NULL || strlen(l_pchUserName) == 0)||\
							(l_pchPassword == NULL )||\
							(l_pchXLFilePath == NULL || strlen(l_pchXLFilePath) == 0)||
							(l_pchXL_WKS_Name == NULL || strlen(l_pchXL_WKS_Name) == 0)||
							(l_pchSQL_Table_Name == NULL || strlen(l_pchSQL_Table_Name)==0))
						{
							MessageBox(NULL,"Please provide valid data.\nData Provided is either NULL or blank","Critical Error",MB_ICONSTOP|MB_OK);
							break;
						}

						//Instantiate Excel DataBase Object and Connect to specified Excel file
						ADO_DataBase_Excel ADODBExcel;
						
						if(FAILED(ADODBExcel.Init()))
						{
							MessageBox(NULL,"Failed to Initialize Application.\nPlease Restart the application","Critical Error",MB_ICONSTOP|MB_OK);
							EndDialog(hDlg, LOWORD(wParam));
						}
						ADODBExcel.SetDataSource(l_pchXLFilePath);
						ADODBExcel.BuildConnString();
						
						if(FAILED(ADODBExcel.ConnectToDB()))
						{
							MessageBox(NULL,"Failed to Connect to DataBase.\nPlease check the options and try again","Critical Error",MB_ICONSTOP|MB_OK);
							break;
						}
						
						
											
						if((SendDlgItemMessage(hDlg,IDC_RADIO_WKS_XLTOSQL,BM_GETCHECK,0,0)) == BST_CHECKED)
						{	if(ADODBExcel.SetWKSorRNGName(l_pchXL_WKS_Name,WORKSHEET)== NULL)
							{
								MessageBox(NULL,"Error while distinguishing between a Worksheet and a Range.\nCheck the Log for details","Critical Error",MB_ICONSTOP|MB_OK);
								break;
							}
						}	
						else
						{	if((SendDlgItemMessage(hDlg,IDC_RADIO_RNG_XLTOSQL,BM_GETCHECK,0,0)) == BST_CHECKED)
								if(ADODBExcel.SetWKSorRNGName(l_pchXL_WKS_Name,RANGE)== NULL)
								{
									MessageBox(NULL,"Error while distinguishing between a Worksheet and a Range.\nCheck the Log for details","Critical Error",MB_ICONSTOP|MB_OK);
									break;
								}
						}
						
						//Retrieve data from excel file
						strcpy(l_pchQueryString,"SELECT * FROM ");
						strcat(l_pchQueryString,l_pchXL_WKS_Name);

						_RecordsetPtr l_pRsExcel = ADODBExcel.ExecuteQuery(l_pchQueryString);//SELECT * FROM TestRange
						if(l_pRsExcel == NULL)
						{
							MessageBox(NULL,"Failed to Retrieve Information from Excel Range/WorkSheet Specified.\nCheck the log for details","Critical Error",MB_ICONSTOP|MB_OK);
							break;
						}
						long l_NoOfColsExcel = 0;
						l_NoOfColsExcel =	ADODBExcel.GetNoOfColumns();
						if(l_NoOfColsExcel == 0)
						{
							MessageBox(NULL,"Failed to Retrieve Number of Columns","Critical Error",MB_ICONSTOP|MB_OK);
							break;
						}
						char l_pcColNamesExcel[10][255];
						char l_pcColTypesExcel[10][50];

						if(FAILED(ADODBExcel.GetColumnNames(l_pcColNamesExcel,l_pcColTypesExcel)))
						{
							MessageBox(NULL,"Failed to Retrieve Column Names","Critical Error",MB_ICONSTOP|MB_OK);
							break;
						}

						//Instantiate SQL Server DataBase Object and Connect to specified DataBase
						ADO_DataBase_SQLServer ADODBSQLServer;
						if(FAILED(ADODBSQLServer.Init()))
						{
							MessageBox(NULL,"Failed to Initialize","Critical Error",MB_ICONSTOP|MB_OK);
							EndDialog(hDlg, LOWORD(wParam));
						}
						ADODBSQLServer.SetDataSource(l_pchServerName);
						ADODBSQLServer.SetInitialCatalog(l_pchDataBaseName);
						ADODBSQLServer.SetUserId(l_pchUserName);
						ADODBSQLServer.SetUserPassword(l_pchPassword);
						ADODBSQLServer.BuildConnString();
						
						if(FAILED(ADODBSQLServer.ConnectToDB()))
						{
							MessageBox(NULL,"Failed to Connect to DataBase.\nPlease check the options and try again","Critical Error",MB_ICONSTOP|MB_OK);
							break;
						}

						//writing Recordset obtained from excel worksheet/range to sql server table
						_variant_t l_varOneRowDataExcel[100];
						HRESULT l_hResult;
						l_hResult = ADODBSQLServer.SimpleCreateTable(l_pchSQL_Table_Name,l_pcColNamesExcel,l_NoOfColsExcel,l_pcColTypesExcel);//"NewTable"
						l_hResult = ADODBSQLServer.InsertAllRows(l_pchSQL_Table_Name,l_pRsExcel,l_NoOfColsExcel,l_varOneRowDataExcel);//"NewTable"
						if(FAILED(l_hResult))
						{
							MessageBox(NULL,"Failed to Migrate Data","Critical Error",MB_ICONSTOP|MB_OK);
							break;
						}
						MessageBox(NULL,"Successfully Migrated Data","Success",MB_ICONINFORMATION|MB_OK);
				
						ADODBExcel.CloseConn();
						ADODBExcel.CloseRecordSet();
						ADODBSQLServer.CloseConn();
						ADODBSQLServer.CloseRecordSet();
					}//end try
					catch(...)
					{
						MessageBox(NULL,"An Unspecified error has occurred","Critical Error",MB_ICONSTOP|MB_OK);
					}
						break;
					}
					
			}
			break;
	}
  return FALSE;
}

LRESULT CALLBACK SQLTOXLProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
	{
		case WM_INITDIALOG:
			{
				if(strlen(l_pchServerName) == 0)
					SendDlgItemMessage(hDlg,IDC_EDIT_SERVERNAME_SQLTOXL,WM_SETTEXT,0,(LPARAM)"SERVER");
				else
					SendDlgItemMessage(hDlg,IDC_EDIT_SERVERNAME_SQLTOXL,WM_SETTEXT,0,(LPARAM)l_pchServerName);
				if(strlen(l_pchDataBaseName) == 0)
					SendDlgItemMessage(hDlg,IDC_EDIT_DATABASENAME_SQLTOXL,WM_SETTEXT,0,(LPARAM)"pubs");
				else
					SendDlgItemMessage(hDlg,IDC_EDIT_DATABASENAME_SQLTOXL,WM_SETTEXT,0,(LPARAM)l_pchDataBaseName);
				if(strlen(l_pchUserName) == 0)
					SendDlgItemMessage(hDlg,IDC_EDIT_USERNAME_SQLTOXL,WM_SETTEXT,0,(LPARAM)"sa");
				else
					SendDlgItemMessage(hDlg,IDC_EDIT_USERNAME_SQLTOXL,WM_SETTEXT,0,(LPARAM)l_pchUserName);

				SendDlgItemMessage(hDlg,IDC_EDIT_PASSWORD_SQLTOXL,WM_SETTEXT,0,(LPARAM)"");

				SendDlgItemMessage(hDlg,IDC_RADIO_WKS_SQLTOXL,BM_SETCHECK,BST_CHECKED,0);
				SendDlgItemMessage(hDlg,IDC_RADIO_RNG_SQLTOXL,BM_SETCHECK,BST_UNCHECKED,0);
				return TRUE;
			}

		case WM_COMMAND:
			switch((LOWORD(wParam)))
			{
				case IDOK:
				case IDCANCEL: 
					{
						EndDialog(hDlg, LOWORD(wParam));
						return TRUE;
					}
				case IDC_BUTTON_LOCATE_SQLTOXL:
					{
						OPENFILENAME l_SaveFileName;
						//InitSaveFileName(&l_SaveFileName,hDlg);

						//Initialize the OPENFILENAME structure
						memset(&l_SaveFileName,0,sizeof(OPENFILENAME));
						l_SaveFileName.lStructSize = sizeof(OPENFILENAME);
						l_SaveFileName.hwndOwner = hDlg;
						l_SaveFileName.hInstance = NULL;
						//l_SaveFileName.lpstrFilter = "Excel Files\0*.xls\0All\0*.*\0";
						l_SaveFileName.lpstrCustomFilter = NULL;
						l_SaveFileName.nFilterIndex = 0;
						l_SaveFileName.lpstrFile = new TCHAR[MAX_PATH];
						memset(l_SaveFileName.lpstrFile,0,MAX_PATH);
						l_SaveFileName.nMaxFile = MAX_PATH-1;
						l_SaveFileName.lpstrFileTitle = new TCHAR[MAX_PATH];
						memset(l_SaveFileName.lpstrFileTitle,0,MAX_PATH);
						l_SaveFileName.nMaxFileTitle = MAX_PATH -1;
						l_SaveFileName.lpstrInitialDir = NULL;
						l_SaveFileName.lpstrTitle = "Provide Name of Excel File";
						l_SaveFileName.Flags = OFN_EXPLORER|OFN_SHOWHELP|OFN_OVERWRITEPROMPT;
						l_SaveFileName.lpstrDefExt = "xls";
						/////////////////////
						
											
						GetSaveFileName(&l_SaveFileName);
						SendDlgItemMessage(hDlg,IDC_EDIT_FILEPATH_SQLTOXL,WM_SETTEXT,0,(LPARAM)l_SaveFileName.lpstrFile);
						//MessageBox(hDlg,l_SaveFileName.lpstrFileTitle,"Debug",MB_OK);
						DWORD err = CommDlgExtendedError();
						break;
					}
				case IDC_BUTTON_FIRE:
					{
						try
						{
						//Gather all the data
						SendDlgItemMessage(hDlg,IDC_EDIT_SERVERNAME_SQLTOXL,WM_GETTEXT,256,(LPARAM)l_pchServerName);
						SendDlgItemMessage(hDlg,IDC_EDIT_DATABASENAME_SQLTOXL,WM_GETTEXT,256,(LPARAM)l_pchDataBaseName);
						SendDlgItemMessage(hDlg,IDC_EDIT_USERNAME_SQLTOXL,WM_GETTEXT,256,(LPARAM)l_pchUserName);
						SendDlgItemMessage(hDlg,IDC_EDIT_PASSWORD_SQLTOXL,WM_GETTEXT,256,(LPARAM)l_pchPassword);
						SendDlgItemMessage(hDlg,IDC_EDIT_FILEPATH_SQLTOXL,WM_GETTEXT,MAX_PATH,(LPARAM)l_pchXLFilePath);
						TCHAR l_pchQueryString[1024];
						memset(l_pchQueryString,0,1024);
						SendDlgItemMessage(hDlg,IDC_EDIT_QUERY,WM_GETTEXT,1024,(LPARAM)l_pchQueryString);
						TCHAR l_pchXLSheetName[256];
						memset(l_pchXLSheetName,0,256);
						SendDlgItemMessage(hDlg,IDC_EDIT_SHEETNAME,WM_GETTEXT,256,(LPARAM)l_pchXLSheetName);

						//Validate Input
						if((l_pchServerName == NULL || strlen(l_pchServerName) == 0)||\
							(l_pchDataBaseName == NULL || strlen(l_pchDataBaseName) == 0)||\
							(l_pchUserName == NULL || strlen(l_pchUserName) == 0)||\
							(l_pchPassword == NULL )||\
							(l_pchXLFilePath == NULL || strlen(l_pchXLFilePath) == 0)||\
							(l_pchQueryString == NULL || strlen(l_pchQueryString) == 0)||\
							(l_pchXLSheetName == NULL || strlen(l_pchXLSheetName) == 0))
						{
							MessageBox(NULL,"Please provide valid data.\nData Provided is either NULL or blank","Critical Error",MB_ICONSTOP|MB_OK);
							break;
						}

						if(IsContainInvalidChars(l_pchXLSheetName))
						{
							MessageBox(NULL,"Sheet Name cannot contain blanks or any special chaacters","Critical Error",MB_ICONSTOP|MB_OK);
							break;
						}

						//Intantiate the SQL Server Object and connect to the DataBase
						ADO_DataBase_SQLServer ADODBSQLServer;
						
						if(FAILED(ADODBSQLServer.Init()))
						{
							MessageBox(NULL,"Failed to Initialize Application.\nPlease Restart the application","Critical Error",MB_ICONSTOP|MB_OK);
							EndDialog(hDlg, LOWORD(wParam));
						}
						ADODBSQLServer.SetDataSource(l_pchServerName);
						ADODBSQLServer.SetInitialCatalog(l_pchDataBaseName);
						ADODBSQLServer.SetUserId(l_pchUserName);
						ADODBSQLServer.SetUserPassword(l_pchPassword);
						ADODBSQLServer.BuildConnString();
						
						if(FAILED(ADODBSQLServer.ConnectToDB()))
						{
							MessageBox(NULL,"Failed to Connect to DataBase.\nPlease check the options and try again","Critical Error",MB_ICONSTOP|MB_OK);
							break;
						}
						
						//Retrieve data from SQL Server DataBase/Table
						_RecordsetPtr l_pRsSQL = ADODBSQLServer.ExecuteQuery(l_pchQueryString);
						if(l_pRsSQL == NULL)
						{
							MessageBox(NULL,"Failed to Execute Query.\nCheck the Log for details","Critical Error",MB_ICONSTOP|MB_OK);
							break;
						}
						long l_NoOfColsSQL = 0;
						l_NoOfColsSQL =	ADODBSQLServer.GetNoOfColumns();
						if(l_NoOfColsSQL == 0)
						{
							MessageBox(NULL,"Failed to Retrieve Number of Columns","Critical Error",MB_ICONSTOP|MB_OK);
							break;
						}
						char l_pcColNamesSQL[10][255];
						char l_pcColTypesSQL[10][50];

						if(FAILED(ADODBSQLServer.GetColumnNames(l_pcColNamesSQL,l_pcColTypesSQL)))
						{
							MessageBox(NULL,"Failed to Retrieve Column Names","Critical Error",MB_ICONSTOP|MB_OK);
							break;
						}


						//Instantiate Excel DataBase Object and Connect to specified Excel Object
						ADO_DataBase_Excel ADODBExcel;
						
						if(FAILED(ADODBExcel.Init()))
						{
							MessageBox(NULL,"Failed to Initialize Application.\nPlease Restart the application","Critical Error",MB_ICONSTOP|MB_OK);
							EndDialog(hDlg, LOWORD(wParam));
						}
						ADODBExcel.SetDataSource(l_pchXLFilePath);
						ADODBExcel.BuildConnString();
						
						if(FAILED(ADODBExcel.ConnectToDB()))
						{
							MessageBox(NULL,"Failed to Connect to DataBase.\nPlease check the options and try again","Critical Error",MB_ICONSTOP|MB_OK);
							break;
						}

						//writing Recordset obtained from sql server to excel worksheet
						_variant_t l_varOneRowData[1024];
						HRESULT l_hResult;
						l_hResult = ADODBExcel.SimpleCreateTable(l_pchXLSheetName,l_pcColNamesSQL,l_NoOfColsSQL,l_pcColTypesSQL);

						if((SendDlgItemMessage(hDlg,IDC_RADIO_WKS_SQLTOXL,BM_GETCHECK,0,0)) == BST_CHECKED)
						{	if(ADODBExcel.SetWKSorRNGName(l_pchXLSheetName,WORKSHEET)== NULL)
							{
								MessageBox(NULL,"Error while distinguishing between a Worksheet and a Range.\nCheck the Log for details","Critical Error",MB_ICONSTOP|MB_OK);
								break;
							}
						}	
						else
						{	if((SendDlgItemMessage(hDlg,IDC_RADIO_RNG_SQLTOXL,BM_GETCHECK,0,0)) == BST_CHECKED)
								if(ADODBExcel.SetWKSorRNGName(l_pchXLSheetName,RANGE)== NULL)
								{
									MessageBox(NULL,"Error while distinguishing between a Worksheet and a Range.\nCheck the Log for details","Critical Error",MB_ICONSTOP|MB_OK);
									break;
								}
						}
						
						l_hResult = ADODBExcel.InsertAllRows(l_pchXLSheetName,l_pRsSQL,l_NoOfColsSQL,l_varOneRowData);
						
						if(FAILED(l_hResult))
						{
							MessageBox(NULL,"Failed to Migrate Data","Critical Error",MB_ICONSTOP|MB_OK);
							break;
						}
						MessageBox(NULL,"Successfully Migrated Data","Success",MB_ICONINFORMATION|MB_OK);
						
						ADODBSQLServer.CloseConn();
						ADODBSQLServer.CloseRecordSet();
						ADODBExcel.CloseConn();
						ADODBExcel.CloseRecordSet();
						}
						catch(...)
						{
							MessageBox(NULL,"An Unexpected Error has occurred","Critical Error",MB_ICONSTOP|MB_OK);
						}
						break;
					}
			}
			break;
	}
    return FALSE;
}


void InitOpenFileName(LPOPENFILENAME a_lpOpenFileName,HWND hDlg)
{
	InitOpenSaveFileName(a_lpOpenFileName,hDlg);
	a_lpOpenFileName->lpstrTitle = "Choose Excel File";
	a_lpOpenFileName->Flags = OFN_EXPLORER|OFN_PATHMUSTEXIST|OFN_FILEMUSTEXIST|OFN_SHOWHELP;
	a_lpOpenFileName->lpstrDefExt = NULL;

}

void InitOpenSaveFileName(LPOPENFILENAME a_lpOpenSaveFileName,HWND hDlg)
{
	memset(a_lpOpenSaveFileName,0,sizeof(OPENFILENAME));
	a_lpOpenSaveFileName->lStructSize = sizeof(OPENFILENAME);
	a_lpOpenSaveFileName->hwndOwner = hDlg;
	a_lpOpenSaveFileName->hInstance = NULL;
	a_lpOpenSaveFileName->lpstrFilter = "Excel Files\0*.xls\0All\0*.*\0";
	a_lpOpenSaveFileName->lpstrCustomFilter = NULL;
	a_lpOpenSaveFileName->nFilterIndex = 0;
	a_lpOpenSaveFileName->lpstrFile = new TCHAR[MAX_PATH];
	memset(a_lpOpenSaveFileName->lpstrFile,'S',MAX_PATH);
	a_lpOpenSaveFileName->nMaxFile = MAX_PATH-1;
	a_lpOpenSaveFileName->lpstrFileTitle = new TCHAR[MAX_PATH];
	memset(a_lpOpenSaveFileName->lpstrFileTitle,'S',MAX_PATH);
	a_lpOpenSaveFileName->nMaxFileTitle = MAX_PATH -1;
	a_lpOpenSaveFileName->lpstrInitialDir = NULL;
}

void InitSaveFileName(LPOPENFILENAME a_lpSaveFileName,HWND hDlg)
{
	InitOpenSaveFileName(a_lpSaveFileName,hDlg);
	a_lpSaveFileName->lpstrTitle = "Choose Excel File";
	//a_lpSaveFileName->Flags = OFN_EXPLORER|OFN_SHOWHELP;
	a_lpSaveFileName->lpstrDefExt = "*.xls";

}

BOOL IsContainInvalidChars(const TCHAR* l_pchCheckString)
{
	while(*l_pchCheckString != '\0')
	{
		if(!isalnum(*l_pchCheckString))
			return TRUE;
		l_pchCheckString++;
	}
	return FALSE;
}


